<template>
  <v-app-bar height="60" elevation="1">
    <template #prepend>
      <v-app-bar-nav-icon
        v-if="$store.state.app.mini"
        class="d-none d-lg-block"
        color="green"
        :icon="$store.state.app.mini ? '' : ''"
        @click="$store.state.app.mini = !$store.state.app.mini"
      ></v-app-bar-nav-icon>
      <v-app-bar-nav-icon
        class="d-block d-lg-none"
        color="green"
        icon="mdi-hamburger"
        @click="drawerHandler"
      ></v-app-bar-nav-icon>
    </template>
    <v-app-bar-title>{{ $route.name }}</v-app-bar-title>
    <v-spacer />
    <v-text-field
      class="elevation-0"
      variant="solo"
      density="compact"
      placeholder="Поиск по товарам"
      hide-details
      @input="searchFieldHandler"
    />
    <v-spacer />
    <template #append>
      <v-btn
        :icon="
          theme.global.name.value === 'light'
            ? 'mdi-weather-night'
            : 'mdi-white-balance-sunny'
        "
        @click="themeHandler"
      ></v-btn>
      <header-basket-menu
        v-if="
          $route.path.includes('/market') || $route.path.includes('/basket')
        "
        :basket="basket"
      />
      <v-btn icon="mdi-bell-outline"></v-btn>
      <auth-login-menu :is-auth="isAuth" :user-name="user?.username" />
    </template>
  </v-app-bar>
</template>

<script setup>
import { dispatch, get, sync } from 'vuex-pathify'
import AuthLoginMenu from '@/components/common/header/AuthLoginMenu.vue'
import HeaderBasketMenu from '@/components/common/header/HeaderBasketMenu.vue'
import { useTheme } from 'vuetify'
import { computed } from 'vue'

const isAuth = get('user/isAuth')
const basket = get('market/basket')
const user = get('user/user')
let { drawer, mini } = sync('app/*')

function searchFieldHandler(event) {
  dispatch('market/setSearchField', event.target.value)
}

function drawerHandler() {
  mini.value = false
  drawer.value = !drawer.value
}

const theme = useTheme()
function themeHandler() {
  theme.global.name.value = theme.global.current.value.dark ? 'light' : 'dark'
}
</script>
